<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import {
  FeaturesContent,
  FeaturesCopyMedia,
  FeaturesFilter,
  FeaturesLandingHero,
  FeaturesMenu,
} from '../../components/features/index.vue';
import { NextStepAlt } from '../../components/common/index.vue';
import { SolutionsResourceCards } from '../../components/solutions/index.vue';
import { getPageMetadata } from '~/common/meta';
import { filterFeaturesHelper } from '~/lib/processFeaturesHelper';

export default Vue.extend({
  name: 'Features',
  components: {
    NextStepAlt,
    FeaturesLandingHero,
    SolutionsResourceCards,
    FeaturesFilter,
    FeaturesCopyMedia,
    FeaturesContent,
    FeaturesMenu,
  },
  nuxtI18n: false,
  async asyncData({ $content }: any) {
    const categoriesObject = await $content('synced/categories').fetch();
    const stageObject = await $content('synced/stages').fetch();
    const featuresFetch = await $content('synced/features').fetch();
    try {
      const doc = await $content(`en-us/features`)
        .where({ slug: { $contains: ['features-partial'] } })
        .sortBy('slug', 'asc')
        .fetch();

      const features = doc.reduce((previous: any, current: any) => {
        const mergedFeature = {
          ...previous,
          ...current,
        };

        return mergedFeature;
      });
      features.tabs.forEach((tab: any) => {
        const stageFormatted = tab.text.toLowerCase();
        const stageAltNames = Array.isArray(tab.altName)
          ? tab.altName
          : [tab.altName];
        const categoryList: any = [];
        const addedCategoryIds = new Set<string>();

        Object.entries(stageObject.stages).forEach(
          ([stageName, stageValue]: any) => {
            if (
              stageName?.includes(stageFormatted) ||
              stageAltNames.some((altName: string) =>
                stageName?.includes(altName),
              )
            ) {
              Object.values(stageValue.groups).forEach(
                ({ categories }: any) => {
                  Object.entries(categories).forEach(([_, categoryId]: any) => {
                    const itemValue = categoriesObject[categoryId] as any;
                    if (itemValue && !addedCategoryIds.has(categoryId)) {
                      // Check for duplicates
                      addedCategoryIds.add(categoryId);
                      categoryList.push({
                        slug: categoryId,
                        name: itemValue.name,
                        description: itemValue.description,
                      });
                    }
                  });
                },
              );
            }
          },
        );

        const featuresArray = categoryList.map((category: any) => {
          return {
            ...category,
            features: filterFeaturesHelper(
              featuresFetch.features,
              features.content_config.filter_features_by,
              category.slug,
            ),
          };
        });
        features[stageFormatted].features = featuresArray;
      });

      return { features };
    } catch (e) {
      throw new Error(e);
    }
  },
  data() {
    return {
      selectedTab: '',
      contentFilter: {
        plan: '',
      },
    };
  },
  head(): MetaInfo {
    return getPageMetadata((this as any).features, this.$route.path);
  },
  mounted() {
    this.selectedTab = this.$route.query.stage
      ? this.$route.query.stage
      : (this as any).features.tabs[0].text.toLowerCase();

    setTimeout(() => {
      if (this.$route.query.stage) this.handleAnchor(this.$route.query.stage);
    }, 1000);
    this.$nextTick(() => {
      if (window.location.hash) {
        setTimeout(() => {
          const sublink = document.getElementById(
            window.location.hash.slice(1),
          );
          sublink.scrollIntoView({ behavior: 'smooth', block: 'start' });
        }, 1000);
      }
    });
  },
  methods: {
    handleAnchor() {
      const featureSection = document.getElementById('feature-section-menu');

      featureSection.scrollIntoView({ behavior: 'smooth', block: 'start' });
    },
    onTabChange(tab: string) {
      this.selectedTab = tab;
      this.contentFilter = {
        plan: '',
      };
      this.handleAnchor();
    },
    onUpdateFilter(newFilter: any) {
      this.contentFilter = {
        plan: newFilter.plan.toLowerCase(),
      };
    },
  },
});
</script>

<template>
  <section class="overflow-clip">
    <SlpContainer>
      <FeaturesLandingHero :data="features.call_to_action" />
      <FeaturesMenu
        v-if="selectedTab"
        :tabs="features.tabs"
        :default-tab="selectedTab"
        :dropdown-label="features.dropdown_label"
        @tabChange="onTabChange"
      />
      <template v-if="features[selectedTab]">
        <FeaturesCopyMedia
          :selected-tab="selectedTab"
          :data="features[selectedTab]['copy_media']"
          :features="features[selectedTab].features"
        />
        <section class="features-section">
          <FeaturesFilter
            :dropdown-label="
              features[selectedTab]['copy_media']['dropdown_label'] ||
              `Selected Feature Category Filter`
            "
            :stage-categories="contentFilter.categories"
            :dropdown-options="
              features[selectedTab]['copy_media']['categories']
            "
            @updateFilter="onUpdateFilter"
          />
          <FeaturesContent
            :selected-tab="selectedTab"
            :data="features[selectedTab]"
            :content-config="features.content_config"
            :filter="contentFilter"
          />
          <SlpSideButton data-ga-name="to-top" data-ga-location="body" />
        </section>
      </template>
    </SlpContainer>
    <SlpContainer>
      <SolutionsResourceCards :data="features.resources" />
    </SlpContainer>
    <NextStepAlt />
  </section>
</template>

<style scoped lang="scss">
.features-section {
  position: relative;
}
</style>
